SystemOrganization addCategory: #'SeasideFAQ-Model'!
SystemOrganization addCategory: #'SeasideFAQ-Tests'!
SystemOrganization addCategory: #'SeasideFAQ-Presentation'!

!WAHtmlStreamDocument class methodsFor: '*SeasideFAQ' stamp: 'mb 1/11/2007 14:22'!
forHtml
	^self new forHtml! !

!WAHtmlStreamDocument methodsFor: '*SeasideFAQ' stamp: 'mb 1/11/2007 14:23'!
forHtml
	state := #body.! !

Object subclass: #WAFAQRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

WAFAQRepository class
	instanceVariableNames: 'default'!

WAFAQRepository class
	instanceVariableNames: 'default'!

!WAFAQRepository class methodsFor: 'instance creation' stamp: 'mb 8/18/2006 15:23'!
default
	default isNil ifTrue: [default := self new].
	^default.! !

!WAFAQRepository methodsFor: 'constants' stamp: 'mb 8/18/2006 16:00'!
categoryUnclassified
	^self repositoryData categoryUnclassified! !

!WAFAQRepository methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:09'!
contents
	| categories categoryRegistry   |
	categoryRegistry := Dictionary new.
	self index do: [:ea | categoryRegistry at: ea put: Set new].
	self repositoryData findAll do:
		[:faq |
		| category |
		category := faq category ifNil: [self categoryUnclassified].
		(categoryRegistry at: category ifAbsentPut: [Set new]) add: faq].
	categories := self index asOrderedCollection collect:
		[:faqCategory |
		| faqs |
		faqs := categoryRegistry at: faqCategory.
		categoryRegistry removeKey: faqCategory.
		faqCategory -> faqs asSortedCollection].
	categoryRegistry keysAndValuesDo:
		[:faqCategory :faqs |
		categories add: faqCategory -> faqs asSortedCollection].
	^categories! !

!WAFAQRepository methodsFor: 'constants' stamp: 'mb 8/18/2006 16:00'!
index
	^self repositoryData index! !

!WAFAQRepository methodsFor: 'accessing' stamp: 'mb 8/18/2006 15:32'!
repositoryData
	^WAFAQRepositoryData default! !

Object subclass: #WAFAQRepositoryData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 17:13'!
categoryDeployment
	^'Deployment and maintenance'! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 17:13'!
categoryErrors
	^'Errors and messages'! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:36'!
categoryGeneral
	^'General'! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:39'!
categoryHowTo
	^'How to'! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:58'!
categoryUnclassified
	^'As yet unclassified'! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:38'!
categoryWhat
	^'What/Why'! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 17:58'!
categoryWhatWrong
	^'What is wrong'! !

!WAFAQRepositoryData class methodsFor: 'singleton' stamp: 'mb 8/18/2006 13:39'!
default
	^self! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 16:14'!
factory
	^WAFrequentlyAskedQuestion! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 10/31/2006 20:43'!
faq1
	^self
		id: 1
		question: 'What is Seaside?'
		category: self categoryGeneral 
		link: 'http://seaside.st'
! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'mb 1/11/2007 15:06'!
faq10
	^self
		id: 10
		question: 'Nothing happens when I click this link?'
		category: self categoryWhatWrong
		title: 'Callback not evaluated with the Canvas api'
		htmlResponse: [:html |
			html paragraph:
'When the callback attached to an anchor is not evaluated, make sure you check that #with: or #text: is the last message sent to the anchor brush.'.
			html preformatted style: 'font-size: 120%'; with:			
'	(html anchor)
		callback: [self close];
		with:
			[(html image)
				fileName: ''closeButton.png'';
				mimeType: ''image/png''].'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 10/31/2006 20:44'!
faq11
	^self
		id: 11
		question: 'What is canvas API, what is the motivation?'
		category: self categoryWhat
		title: 'The canvas API by Avi Bryant'
		htmlResponse:

'
<p style="font-size: 80%">See original post <a href="http://lists.squeakfoundation.org/pipermail/seaside/2005-June/005260.html">here</a>.</p>
<p>
The basic problem that Canvas is trying to solve is that of
combinatorial explosion in the protocol of WAHtmlRenderer.  Consider
something like a text input.  The original, basic method for rendering
a text input was #textInputWithValue:callback:
</p><pre style="font-size: 120%">
	html textInputWithValue: person name callback: [:v | person name: v]
</pre><p>
But there&quot;s also a variation using the ...On:of: pattern:
</p><pre style="font-size: 120%">
	html textInputOn: #name of: person
</pre><p>
And a variation with a liveUpdate callback:
</p><pre style="font-size: 120%">
	html
		textInputWithValue: person name
		callback: [:v | person name: v]
		liveCallback: [:r :v | ...]
</pre><p>
Now what if we want to use both of these variations at once?  Do we
also need #textInputOn:of:liveCallback:?  What about
#passwordInputOn:of:liveCallback:?   And so on.  It&quot;s relatively easy
to add new convenience methods, but it&quot;s a huge pain to combine them,
even when (as in this case) they&quot;re totally orthogonal.
</p><p>
The Canvas renderer is just a slight change to the API style that
makes this kind of combination much easier.  It divides what would
have been a single method on HtmlRenderer into three steps:  first,
you tell the canvas what kind of "brush" (tag, usually) you want to
use.  For example, the method #textInput will return a new instance of
WATextInputTag.  Then, you use protocol specific to that brush to
configure it: for example, you might send it some combination of
#value:, #callback:, #liveCallback:, #on:of:, etc.  You almost never
need to use temps when doing this, but can do it with cascades
instead:
</p><pre style="font-size: 120%">
	(html textInput)
		value: person name;
		callback: [:v | person name: v]
</pre><p>
or
</p><pre style="font-size: 120%">
	html textInput on: #name of: person
</pre><p>
or
</p><pre style="font-size: 120%">
	(html textInput)
		on: #name of: person;
		liveCallback: [:r :n | ....]
</pre><p>
The third step is to render any contents or children (if any) of this
tag.  You do this by passing some renderable (often a block) to the
method #with:.  A text input wouldn&quot;t have any, but consider something
like a table:
</p><pre style="font-size: 120%">
	(html tableRow)
		rowSpan: 3;
		with:
		     [html tableData with: [html bold with: person name].
		     (html tableData) colSpan: 2; with: [....]]
</pre><p>
Note that instead of using #attributeAt:put: before the element, as in
HtmlRenderer, attributes are set as part of the configuration step -
and so classes like WATableRow can implement convenience methods for
common attributes like #rowSpan: as needed.
</p><p>
If no configuration is needed, you can combine the first and third
steps by using a keyword message instead of a unary message to specify
the brush type, which is more compact:
</p><pre style="font-size: 120%">
	(html tableRow)
		rowSpan: 3;
		with:
		    [html tableData: [html bold: person name].
		    html tableData ....]
</pre><p>
This style of API still allows streaming - the HTML for the open tag
is generated as soon as #with: is sent.  If #with: is never sent, it&quot;s
triggered automatically (with an empty block) whenever the next tag is
started.  That means #with: does have to be the last thing you send,
any configuration done afterwards will have no effect.
</p><p>
Sometimes a temp is handy:
</p><pre style="font-size: 120%">
	myDiv := html div.
	self useSpecialClass ifTrue: [myDiv class: &quot;specialClass&quot;].
	myDiv with: [html text: ....]
</pre><p>
But bear in mind that these are basically temporary objects - it won&quot;t
do you any good to stash them in an ivar and try to use them later,
for example.
</p><p>
The Canvas implementation in recent 2.6a versions is relatively
complete (we&quot;re using it on one of the projects I&quot;m working on), but
there are no doubt still lots of holes to patch up and conveniences to
add, so feel free to pitch in.
</p>
<p>Avi Bryant<br />Mon Jun 20 17:18:45 CEST 2005</p>
'! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'mb 1/11/2007 16:34'!
faq12
	^self
		id: 12
		question: 'I have problems with the canvas api, where should I look?'
		category: self categoryWhatWrong
		title: 'Canvas troubles'
		response:

'Make sure you check that #with: or #text: is the last message sent to the anchor brush.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/25/2007 09:20'!
faq13
	^self
		id: 13
		question: 'What is the most simple way to serve files from a Seaside application?'
		category: self categoryHowTo
		title: 'Serving files'
		htmlResponse: [:html |
			html paragraph:
'The most convenient way to serve files like pictures or stylesheets from a Seaside application is WAFileLibrary. See the class comment of WAFileLibrary for more information about how to use it.'.
			html paragraph:
'The following assumes that you have defined MyFileLibrary as explained in the class comment.'.
			html paragraph:
'First you will need to setup the root of your library. Typically this can be returned by a method.'.
			html preformatted style: 'font-size: 120%'; with:
'	library
		^WAUrl new addToPath:
			(WADispatcher default basePath , ''/files/MyFileLibrary/'').
'.
			html paragraph:
'To display an image'.
			html preformatted style: 'font-size: 120%'; with:
'		html image url: (self library addToPath: ''myPicture.png'').
'.
			html paragraph:
'To display an image button (within a form)'.
			html preformatted style: 'font-size: 120%'; with:
'		html imageButton
			url: (self library addToPath: ''myButton.gif'');
			callback: [self commit].
'.
			html paragraph:
'To add a stylesheet and a javascript'.
			html preformatted style: 'font-size: 120%'; with:
'	updateRoot: anHtmlRoot
		super updateRoot: anHtmlRoot.
		anHtmlRoot stylesheet url: (self library addToPath: ''myStyle.css'').
		anHtmlRoot javascript url: (self library addToPath: ''myJavascript.js'').
'.
			html paragraph:
'Advanced users might want to use Apache 2.'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 14:10'!
faq14
	^self
		id: 14
		question: 'How do I access the initial request fields in my root component or task?'
		category: self categoryHowTo
		title: 'Accessing fields of initial request'
		response:

'To access the initial request fields in a root component or task override #initialRequest:. You will get a request object as argument that you can ask for #fields.'! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'mb 1/11/2007 16:34'!
faq15
	^self
		id: 15
		question: 'I have problems with forms or input fields, where should I look?'
		category: self categoryWhatWrong
		title: 'Form or input field troubles'
		response:

'Make sure that you have one, and only one form around your input fields.'! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'mb 1/11/2007 15:05'!
faq16
	^self
		id: 16
		question: 'Are there any special hosting offers for seaside applications?'
		category: self categoryGeneral
		title: 'Seaside Hosting'
		htmlResponse: [:html |
			html text: 'There is '.
			html anchor
				url: 'http://www.seasidehosting.st';
				with: 'Seaside-Hosting'.
			html text: ' which is a free hosting service for non-commercial Seaside applications. '.
			html text: 'It is only for Squeak.'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 11/4/2006 17:45'!
faq17
	^self
		id: 17
		question: 'What is the new header API, what is the motivation?'
		category: self categoryWhat
		title: 'The canvas header API'
		htmlResponse:

'
<p style="font-size: 80%">See original post <a href="http://lists.squeakfoundation.org/pipermail/seaside/2006-October/009570.html">here</a>.</p>

<p>Hi</p>

<p>Now that both Seaside 2.7a1 and 2.6b1 have the "new" header API i think its time
to write something short about it so people don''t have to ask.</p>

<p>The old header API was suffering from the same problems as the old
renderer API. Just to add an stylesheet with media and title you had
to copy and paste about 4 methods. Addional 4 for alternate
stylesheets. If you wanted a new conditional import you needed to copy
and paste a 3 LOC method.  And so on. So we followed the same path
like the Canvas API and made use of cascades.</p>

<p>The new API offers four base methods to create elements
<ul>
<li>base, for base elements</li>
<li>if, for conditional imports</li>
<li>link, for link elements</li>
<li>meta, for meta elements</li>
<li>script, for script elements</li></ul></p>

<p>Most of the time will want to use one of these two convenience methods:
<ul>
<li>javascript, for javascripts</li>
<li>stylesheet, for css stylesheets</li></p>

<p>See WABaseElement, WAConditionalComment, WALinkElement, WAMetaElement and
WAScriptElement for details</p>

<p>examples:</p>

<p></p><pre style="font-size: 120%">
aRoot stylesheet
    url: ''styles/blue.css''
</pre></p>

<p></p><pre style="font-size: 120%">
aRoot stylesheet
    document: ''a { color:red; }''
</pre></p>

<p></p><pre style="font-size: 120%">
aRoot javascript
    url: ''scripts/scriptaculous.css''
</pre></p>

<p></p><pre style="font-size: 120%">
aRoot if lessThan; ie7; do: [
    aRoot javascripts
        url: ''iehacks.js'' ]
</pre></p>

<p>stuff that was just awkward to do with the old api:</p>

<p></p><pre style="font-size: 120%">
aRoot link beAlternateStylesheet; beCss;
    addProjection; addPrint;
    title: ''Blue'';
    url: ''styles/blue.css''
</pre></p>

<p>Contrary to the Canvas renderer API the new header API in the
background still used the old implementation. So you will have to
implement no methods like #rendererClass.</p>

<p>If you use the old API on Seaside 2.7a1 and have the development toolbar on you
will get a warning pointing to where you use the old API. These methods include
the code that you should replace yours with.</p>

</p>Philippe<p>'! !

!WAFAQRepositoryData class methodsFor: 'faq errors' stamp: 'mb 1/11/2007 15:07'!
faq18
	^self
		id: 18
		question: 'Error: Components not found while processing callbacks: ....'
		category: self categoryErrors
		title: 'Components not found'
		response:
		
'Make sure return any subcomponents of a component in the #children method. If the subcomponents change over the lifetime of the component, register it for backtracking.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 16:26'!
faq19
	^self
		id: 20
		question: 'How do I clean up external resources owned by Seaside sessions?'
		category: self categoryHowTo
		title: 'Cleaning up Seaside sessions'
		response:

'When a Seaside session is not used during a certain duration, it expires. After a session has expired, it cannot be used any more.

By default, this duration is 10 minutes (600 seconds) but it can be set to any other desired value using the "config" application ("Session Expiry" field). It can also be set programmatically

	app preferenceAt: #sessionExpirySeconds put: 1200

From time to time, Seaside processes expired sessions (see #unregisterExpiredHandlers). Expired sessions are removed from Seaside, making them candidates for future garbage collections, then they are sent #unregistered. The standard implementation of #unregistered in WASession is empty.

If it is necessary to release resources held by an expired Seaside session, this can be done by subclassing WASession and by reimplementing the #unregistered method. 

'! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 10/31/2006 20:43'!
faq2
	^self
		id: 2
		question: 'Is Seaside ready for production?'
		category: self categoryGeneral 
		title: 'Is Seaside production ready'
		response:

'Seaside is used productively for many commercial and non-commercial applications.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 16:19'!
faq20
	^self
		id: 19
		question: 'How do I subclass WASession?'
		category: self categoryHowTo
		title: 'Subclassing WASession'
		response:

'It is sometimes necessary to subclass WASession. Typical situations for subclassing WASession.

- Need to clean-up external resources when Seaside session expires (reimplement #unregistered)
- Need to attach some data to the Seaside session using additional instance variables
- Need to include additional behavior, statistics, monitoring (reimplement #responseForRequest:)

Seaside applications are assigned their session class using the "config" application ("Session Class" field). It can also be set programmatically

	app preferenceAt: #sessionClass put: MySession

'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 17:58'!
faq21
	^self
		id: 21
		question: 'How do I subclass WAApplication?'
		category: self categoryHowTo
		title: 'Subclassing WAApplication'
		response:

'It is sometimes necessary to subclass WAApplication, for instance when it is needed to display a session expiration page.

When you subclass WAApplication, make sure that the subclass reimplements #description on the class side, this will ensure that you can differentiate the WAApplication subclasses in the "config" application. Once the WAApplication is in place you can use the "config" application to create your Seaside application.

New Seaside applications can also be created programmatically by carefully reimplementing #applicationWithPath: on the class side of your root component.

'! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'mb 1/11/2007 16:53'!
faq22
	^self
		id: 22
		question: 'My Seaside session object does not receive #unregistered?'
		category: self categoryWhatWrong
		title: 'Cleaning up Seaside sessions'
		htmlResponse: [:html |
			html paragraph:
'When a Seaside session is not used during a certain duration, it expires. After a session has expired, it cannot be used any more.'.
			html paragraph:
'From time to time, Seaside processes expired sessions and sends them #unregistered. This is not immediate and it may take some time before Seaside enters this expiry process. With its default algorithm, Seaside expiry process occurs only when starting a new session, once every 10 sessions in average (see #registerRequestHandler: and #shouldCollectHandlers). If no new session are started, the #unregistered message is not sent. The more new sessions are created, the more the #unregistered message is sent.'.
			html paragraph:
'Beware, a common mistake is to name the method #unregister rather than #unregistered'.

			html heading: 'Avi Bryant 3 Oct 2004' level:4.
			html paragraph style: 'font-size: 80%'; with: [
				html anchor url: 'http://lists.squeakfoundation.org/pipermail/seaside/2004-October/003704.html'; with: 'Original post'].
			html paragraph:
'One of the things I added in the recent 2.5b5 release was an ExpiryTest  application which let me do some ad-hoc testing of the expiration and unregistration mechanism. As far as I can tell, things are actually working, although it''s fairly erratic when exactly #unregistered will get sent - usually quite a while after the session actually expires, since the cleanup is only triggered by (on average) every 10th new session creation.'.
			html paragraph:
'If you want to play with this yourself, execute "WAExpiryTest install" and then go to /seaside/expiry. Hopefully the links/stats are fairly self explanatory.'.
			html paragraph:
'I think what I will probably do is start a background process that does the cleanup every few minutes, instead. The only small concern I have about this is that it''s one more thing to break - you might not notice that the cleanup process had died somehow, and end up with a lot of expired sessions sitting around in memory. The way it is now, it''s tied directly to the web server process, and if that goes down you''ll hear about it :).'.
			html paragraph:
'Avi'.
			]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 17:58'!
faq23
	^self
		id: 24
		question: 'How do I get the requester''s IP address?'
		category: self categoryHowTo
		title: 'Getting the requester''s IP address'
		response:

'It is sometimes necessary to know the IP address of the requester. For instance you may want to produce a different behavior when the request comes from "localhost".

The IP address is normally available from the native request object. The native request object is obtained by sending #nativeRequest to the current Seaside request object, like this

	renderContentOn: html
		nativeRequest := self session currentRequest nativeRequest.
		
The native request object will be a Kom request, a Swazoo request or a WebToolkit request depending on the exact environment.

For instance, with Squeak

		ipAddress := nativeRequest remoteAddress. 	


'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 17:58'!
faq24
	^self
		id: 23
		question: 'How do  I display an expiration page?'
		category: self categoryHowTo
		title: 'Displaying an expiration page'
		response:

'When the user wants to reuse an expired Seaside session, Seaside silently starts a new session. It is sometimes necessary to change this default behavior and notify the user that the session has expired. 

First thing to do is to subclass WAApplication. Next thing is to reimplement either #handleExpiredRequest: or #expiryPathFor:

In #handleExpiredRequest: you are given a chance to build a redirect response to another Seaside application that will display the expiration component.

Below is a very simple example based on reimplementing #expiryPathFor:

	expiryPathFor: aRequest
		^ self basePath , ''?expired=true''

The expired=true field can be obtained by implementing #initialRequest: in the application root component, for instance

	initialRequest: aRequest
		(aRequest fields includesKey: ''expired'') ifPresent: [restartedAfterExpiration := true].

The rendering can then take expiration into consideration, for instance

	renderContentOn: html
		restartedAfterExpiration == true
			ifTrue:
				[self renderExpiredOn: html]
			ifFalse:
				[self renderNormal On: html]

'! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'mb 1/11/2007 18:20'!
faq25
	^self
		id: 25
		question: 'What is source code structure of Seaside in VisualWorks?'
		category: self categoryWhat
		title: 'Bundle structure of Seaside in VisualWorks public repository'
		htmlResponse:

'
<p>For many different reasons Seaside is broken into a complex and cumbersome bundle/package structure.</p>
<p>At a higher level, Seaside is broken into three bundles :
<ul>
	<li>Seaside-VW</li>
	<li>Seaside</li>
	<li>Seaside-WekToolKit</li>
</ul>
that must be loaded in the exact same order shown above.</p>

<p>The first bundle Seaside-VW contains pre-requisites and is actually preparing VisualWorks for Seaside. This bundle also has a complex structure. See below for further details.</p>
<p>The second bundle Seaside contains the original Seaside code unaltered from Squeak. The structure of this bundle is derived from the corresponding Seaside Monticello package. No further details are provided here.</p>
<p>The third bundle Seaside-WebToolKit contains the integration code for running Seaside inside the WebToolkit framework, along with some patches to both Seaside and WebToolkit. See below for more information.</p>
<p><strong>Note:</strong> There exists also a Seaside-Swazoo bundle that contains the integration code for running Seaside inside the Swazoo framework. This is described below in more details.</p>
<p><strong>One-click loading:</strong> Loading Seaside means loading the three bundles in the order above, making sure the bundle versions are compatible. However to provide one-click loading, there is another bundle named SeasideForWebToolkit that contains a script that loads the three bundles programmatically.</p>

<p>The contents of the Seaside-VW bundle are :
<ul>
	<li>Squeak-Chronos - This bundle adds Squeak compatibility to the base VisualWorks image and includes a full port of the Squeak Chronology classes providing classes like Duration, Year, Month, Week, etc. This bundle contains all the known Squeak compatibility extensions that could be found in the repository. It can be used for any project that needs Squeak compatibility.</li>
	<li>Seaside-Store-Patch - This package includes a patch to Store to allow loading of packages that include a $/ in their name. Note : Those names were given a few years ago, renaming those packages would be a risky task.</li>
	<li>Seaside - This package defines the Seaside namespace. The definition of the Seaside namespace was originally done in the Seaside bundle (see below). However it had to be defined earlier so that the Squeak versions of the Date, Time, TimeZone and Color classes could be made available to the Seaside namespace.</li>
	<li>Seaside/VW Support - This package includes extensions to the VisualWorks classes that are needed by Seaside. It also includes the SeasidePlatformSupport class that is expected by Seaside. This class includes many utilities on the class side that are used to create the Seaside ports. Method #portSource answers a constant that represents the original source of the Seaside Monticello package.</li>
</ul></p>
<p>The contents of the Seaside-WebToolKit bundle are :
<ul>
	<li>Seaside/Patches - This package includes patches to the Seaside code in the form of extensions and overrides. These patches are there to fix issues that are still not fixed in the Seaside Squeak source.</li>
	<li>WebToolkit/Patches - This package includes patches to the WebToolkit code in the form of extensions and overrides. These patches are there to fix issues that are still not fixed in the WebToolkit product.</li>
	<li>Seaside/WebToolkit - This package contains the actual integration between Seaside and WebToolkit, i.e. pieces of software that are specific to WebToolkit. The most important item is the SeasideServlet class. Of interest is the AAADocumentation class that provides guidelines on how to set things up and a few methods that are used to build the sample HTTP server and the sample web site.</li>
</ul></p>
<p>The contents of the Seaside-Swazoo bundle are :
<ul>
	<li>Seaside/GIF - This package includes some classes from VisualWave that are needed to support GIF images, since Swazoo does not have any support for GIF.</li>
	<li>Swazoo/Patches - This package includes patches to the Swazoo code in form of extensions and overrides. It adds explicit support for cookies that is missing in Swazoo.</li>
	<li>Seaside/Patches - This package is the same as the one included in the Seaside-WebToolKit. See above.</li>
	<li>Seaside/Swazoo - This package contains the actual integration between Swazoo and WebToolkit, i.e. pieces of software that are specific to Swazoo. The most important item is the SeasideResource class. Of interest is the AAADocumentation class that provides guidelines on how to set things up and a few methods that are use to build the sample Swazoo server.</li>
</ul></p>
'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 18:39'!
faq26
	^self
		id: 26
		question: 'How do I make Seaside VisualWorks serve shorter URLs such as http://localhost:8008/counter?'
		category: self categoryHowTo
		title: 'Serving a shorter URL for VisualWorks'
		response:

'If you would like to make the VisualWorks Seaside application server manage all the path-information on its own and to let it appear in the root like:

	http://localhost:8008/counter

then you need to load the SeasideShortPath parcel that can be found in the contributed/other/Seaside/BonusPack directory starting with VisualWorks 7.3'! !

!WAFAQRepositoryData class methodsFor: 'faq deployment' stamp: 'mb 1/11/2007 18:39'!
faq27
	^self
		id: 27
		question: 'How to deploy Seaside VisualWorks behing Apache?'
		category: self categoryDeployment
		title: 'Running behind Apache'
		htmlResponse: [:html |
			html paragraph:		
'You can run Seaside under VisualWorks behind Apache using either the the CGI gateway or the CGI Perl Interface.'.
			html paragraph:		
'There is however some potential difficulties to take into consideration. By default, Seaside is designed to use only one WADispatcher object and the WADispatcher object has a hard-coded base URI. Therefore, if you start your image, access Seaside through TinyHttpServer, then access Seaside through Apache, the access through Apache should fail because the WADispatcher object has been initialized with the TinyHttpServer URI and does not recognize the Apache URI.'.
			html paragraph:		
'For instance if the first Seaside visitor comes in through TinyHttpServer with a request for ''seaside/go/counter'', the WADispatcher base path will be ''seaside/go''. When another visitor comes in through Apache with a request for ''cgi-bin/visualworks.pl/seaside/go/counter'', Seaside uses the REQUEST_URI environment variable and the WADispatcher does not find any match.'.
			html paragraph:		
'The problem would be solved if the Apache request would come with REQUEST_URI equals to ''seaside/go/counter''. This might be possible by modifying the perl script so that it modifies the REQUEST_URI variable before transfering the HTTP request to VisualWorks.'.
			html paragraph: [
				html text:		
'I (Michel Bany) recently made an attempt to solve this issue differently by implementing the concept of alternate servlet. See the Seaside '.
				html anchor url: 'http://lists.squeakfoundation.org/pipermail/seaside/2004-September/003627.html'; with: 'mailing list post'.
				html text: '.'].
			html paragraph:		
'With this concept there are two SeasideServlet instances rather than just one. Each instance has its own separate WADispatcher object. As a result you may serve Seaside applications through two different base URIs.'.
			html paragraph:		
'The alternate servlet support has been included in VW 7.3.'.
			html paragraph:		
'The parcel for alternate servlet support is inside the BonusPack folder and is named SeasideShortPath.
You will need to use a different URI when coming through Apache, something like for ''/cgi-bin/visualworks.pl/counter'' rather than for ''cgi-bin/visualworks.pl/seaside/go/counter''. With the later, Seaside would attempt to use the default servlet and would fail. With the former, it will drop into the alternate servlet and initialize a new WADispatcher with the right base path.
Having explained all this, I believe that the best solution will be to have multiple WADispatcher objects available for the SeasideServlet providing support for multiple channels into Seaside.'.
			]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 18:42'!
faq28
	^self
		id: 28
		question: 'How do I reset the Seaside administrator password?'
		category: self categoryHowTo
		title: 'Viewing and resetting Seaside passwords'
		response:

'To view
	
	(WADispatcher default entryPoints at: ''config'') preferenceAt: #login.

	(WADispatcher default entryPoints at: ''config'') preferenceAt: #password.

and to change:

	(WADispatcher default entryPoints at: ''config'')
			preferenceAt: #login put: ''new id''.

	(WADispatcher default entryPoints at: ''config'')
			preferenceAt: #password put: ''new password''.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 2/7/2007 20:28'!
faq29
	^self
		id: 29
		question: 'How do I purge all existing sessions that might be open.?'
		category: self categoryHowTo
		title: 'Viewing and resetting Seaside passwords'
		response:

'<code></pre>WARegistry clearAllHandlers.
Smalltalk garbageCollect.<pre></code>'! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'mb 1/11/2007 15:05'!
faq3
	^self
		id: 3
		question: 'Applications built with Seaside'
		category: self categoryGeneral 
		htmlResponse: [:html |
			html text: 'As mentionned in the '.
			html anchor
				url: 'http://lists.squeakfoundation.org/pipermail/seaside/2003-August/001929.html';
				with: 'mailing list'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'mb 1/11/2007 15:06'!
faq4
	^self
		id: 4
		question: 'Where can I find Seaside tutorials?'
		category: self categoryGeneral 
		htmlResponse: [:html |
			html text: 'As comprehensive list of tutorials can be found on the '.
			html anchor
				url: 'http://seaside.st/Tutorial/';
				with: 'Seaside tutorials page'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'mb 1/11/2007 15:06'!
faq5
	^self
		id: 5
		question: 'Is Seaside free? What license does Seaside use?'
		category: self categoryGeneral
		title: 'Seaside License'
		htmlResponse: [:html |
			html paragraph:
'As of the Seaside 2.5 release (which was beta as of 2004 Jan 08), Seaside has been under the MIT license. This means that you can use it to build commercial apps, royalty free, with no restrictions. Note that, besides Squeak, this also applies to commercial Smalltalks such as VisualWorks and Dolphin Smalltalk.'.
			html paragraph: 
				[html text: 'See more details on the '.
				html anchor
					url: 'http://seaside.st/License/';
					with: 'Seaside license page'.
				html text: '.']
			]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 10/31/2006 20:43'!
faq6
	^self
		id: 6
		question: 'How do I get Seaside?'
		category: self categoryGeneral
		title: 'Seaside Installation'
		htmlResponse:

'<h5>Squeak</h5>

<p>The tutorial <a href="http://beta4.com/seaside2/tutorial.html">A Walk on the Seaside</a> describes the installation procedure. Note that to install KomHttpServer, you need to install KomServices which in turns requires DynamicBindings.</p

<h5>VisualWorks</h5>
<p>Starting with version 7.2.1, Seaside is shipped on the VisualWorks distribution CD.</p>
<p>Seaside can be loaded in the VisualWorks image using the Parcel Manager, section "Application Server" where you should be able to see the SeasideForWebToolkit parcel. There is some installation documentation in the parcel comments.</p>
<p>Seaside can also be loaded from the public Store repository where  either of the following bundles can be loaded :
- SeasideForWebToolkit, or
- SeasideForSwazoo</p>
<p>Usually, loading from the repository may give you a more recent version 
of Seaside, also it gives the choice of loading older versions of Seaside.
Since the repository is used to build the Seaside ports, it is possible
to get an unstable version, therefore it is recommended to load Seaside
from your hard disk using the Parcel Manager, unless you want to experiment
with newer versions of Seaside or if you are using a version of VisualWorks
older than 7.2.1.</p>
<p>After the VisualWorks installation, Seaside is located in the goodies/contributed/Seaside directory. More items can be found in this directory using the File Browser or the Parcel Manager, like an HTML Seaside introductory tutorial and the original Squeak code.</p>
<p>Since VisualWorks 7.3 Seaside comes with even more items that can be found in this directory:</p>
<ul>
<li>SeasideForSwazoo - A parcel for using Seaside with Swazoo rather than WebToolkit. Note: you may load both SeasideForWebToolkit and SeasideForSwazoo in the same image.</li>
<li>SqueakBase - A prerequisite parcel that provides some compatibility with Squeak and that includes all the known Squeak compatibility extensions that could be found in the repository.</li>
<li>SeasideAsync - An optional parcel that adds AJAX capabilities to Seaside.</li>
<li>BonusPack - A bunch of parcels with Seaside examples, Seaside goodies like Adrian Lienhard&quot;s Mewa, Lukas Renggli&quot;s Scriptaculous library, the Web designer tool for manipulating graphic files, CSS stylesheets and Javascripts, plus various optional utility parcels.</li>
</ul>


<h5>Dolphin Smalltalk</h5>

'! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 10/31/2006 20:44'!
faq7
	^self
		id: 7
		question: 'What is the difference between WAComponent(component) and WATask(task)?'
		category: self categoryWhat
		title: 'Difference Between Component And Task'
		response:

'Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn''t render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.
'! !

!WAFAQRepositoryData class methodsFor: 'faq deployment' stamp: 'pmm 10/31/2006 20:44'!
faq8
	^self
		id: 8
		question: 'How to exclude applications from the Seaside main dispatcher?'
		category: self categoryDeployment
		title: 'Excluding applications for deployment'
		response:

'Before deploying for production, it is not a bad idea to remove from the Seaside dispatcher all those applications that are not strictly needed. Otherwise, users may accidentally enter the "counter" or the "store" demo applications.

First of all, you will have to explicitely designate those Seaside applications that are deployed. This is achieved by re-implementing the #isDeployed class method in the root component of the deployed applications. By default, this class method answers false, only the dispatcher editor ("config") and the dispatcher navigator ("browse") answer true.

Then ,to remove applications from the Seaside dispatcher, evaluate the following:

WADispatcher default trimForDeployment.

This will remove all those applications that answer false to message #isDeployed.
'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'mb 1/11/2007 15:07'!
faq9
	^self
		id: 9
		question: 'How do I remove the tool bar?'
		category: self categoryHowTo
		title: 'Removing the tool bar'
		htmlResponse: [:html |
			html paragraph:
'Set the value of "Deployment Mode" to false using the dispatcher editor ("config").'.
			html paragraph:
'This can be also done programatically in the #initialize method of the application''s root component.'.
			html preformatted style: 'font-size: 120%'; with:
'	initialize
		| app |
		app := self registerAsApplication: '';app-name''.
		app preferenceAt: #deploymentMode put: true.'
			]
	! !

!WAFAQRepositoryData class methodsFor: 'finding' stamp: 'mb 8/18/2006 16:14'!
findAll
	^(self class methodDictionary keys select:
		[:selector |
		selector beginsWith: 'faq'])
	collect:
		[:selector |
		self perform: selector].
! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 1/11/2007 14:27'!
id: i question: q category: c htmlResponse: r 
	^self id: i question: q category: c title: nil htmlResponse: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 15:52'!
id: i question: q category: c link: r 
	^self id: i question: q category: c type: self typeLink title: nil response: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 15:47'!
id: i question: q category: c response: r 
	^self id: i question: q category: c title: nil response: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 1/11/2007 14:33'!
id: i question: q category: c title: tit htmlResponse: aBlockOrString 
	| aRenderingContext anHtmlRenderer html |
	html := aBlockOrString isString
		ifTrue:
			[aBlockOrString]
		ifFalse:
			[aRenderingContext := WARenderingContext new document: WAHtmlStreamDocument forHtml.
			anHtmlRenderer := WARenderCanvas context: aRenderingContext callbacks: nil.
			aBlockOrString value: anHtmlRenderer.
			aRenderingContext document stream contents].
	^self id: i question: q category: c type: self typeHtml title: tit response: html! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 15:46'!
id: i question: q category: c title: tit response: r 
	^self id: i question: q category: c type: self typeText title: tit response: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 15:46'!
id: i question: q category: c type: typ response: r 
	^self id: i question: q category: c type: typ title: nil response: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 16:13'!
id: i question: q category: c type: typ title: tit response: r 
	^self factory id: i question: q category: c type: typ title: tit response: r ! !

!WAFAQRepositoryData class methodsFor: 'faq index' stamp: 'pmm 11/4/2006 17:36'!
index
	"Used to order the categories in the UI"
	^(OrderedCollection new)
		add: self categoryGeneral;
		add: self categoryWhat;
		add: self categoryHowTo;
		add: self categoryWhatWrong;
		add: self categoryDeployment;
		add: self categoryErrors;
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 16:15'!
typeHtml
	"Text with embedded HTML"
	^#html! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:38'!
typeLink
	"Only an URL to foreign web page"
	^#link! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:37'!
typeText
	"Normal text, no embedded HTML"
	^#text! !

Object subclass: #WAFrequentlyAskedQuestion
	instanceVariableNames: 'id question category type title response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

!WAFrequentlyAskedQuestion class methodsFor: 'instance creation' stamp: 'mb 8/18/2006 15:32'!
id: i question: q category: c type: typ title: tit response: r
	^self new id: i question: q category: c type: typ title: tit response: r ! !

!WAFrequentlyAskedQuestion methodsFor: 'comparing' stamp: 'mb 8/18/2006 16:20'!
<= another
	^self id <= another id! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
category
	^ category! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 13:34'!
id
	^ id! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 13:35'!
id: anInteger
	id := anInteger! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:53'!
id: i question: q category: c type: typ title: tit response: r 
	id := i.
	question := q.
	category := c.
	type := typ.
	title := tit.
	response := r.! !

!WAFrequentlyAskedQuestion methodsFor: 'testing' stamp: 'mb 8/18/2006 13:58'!
isHtml
	^self type = self repository typeHtml! !

!WAFrequentlyAskedQuestion methodsFor: 'testing' stamp: 'mb 8/18/2006 13:58'!
isLink
	^self type = self repository typeLink! !

!WAFrequentlyAskedQuestion methodsFor: 'testing' stamp: 'mb 8/18/2006 13:58'!
isText
	^self type = self repository typeText! !

!WAFrequentlyAskedQuestion methodsFor: 'printing' stamp: 'mb 8/18/2006 13:46'!
printOn: aStream
	aStream
		nextPutAll: 'FAQ #';
		nextPutAll: self id printString! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
question
	^question! !

!WAFrequentlyAskedQuestion methodsFor: 'private' stamp: 'mb 8/18/2006 16:20'!
repository
	^WAFAQRepositoryData default! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
response
	^ response! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
title
	^ title ifNil: [question].! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:28'!
type
	^ type! !

WAComponent subclass: #WAFAQ
	instanceVariableNames: 'currentCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Presentation'!

!WAFAQ class methodsFor: 'documentation' stamp: 'mb 8/18/2006 12:23'!
description
	^'Frequently asked questions'! !

!WAFAQ class methodsFor: 'class initialization' stamp: 'mb 8/18/2006 14:12'!
initialize
	| app |
	app := self registerAsApplication: 'faq'.
	app libraries add: SULibrary! !

!WAFAQ methodsFor: 'actions' stamp: 'mb 8/18/2006 14:07'!
displayResponseFor: faq
	self lightbox: (WAFAQResponse for: faq)
! !

!WAFAQ methodsFor: 'rendering' stamp: 'mb 8/18/2006 14:02'!
renderCategory: cat on: html

	| optionalPlural text |
	cat value size = 0 ifTrue:
		[html text: cat key , ' (no item)']
	ifFalse:
		[optionalPlural := cat value size > 1 ifTrue: ['s'] ifFalse: [''].
		text := '(' , cat value size printString , ' item' , optionalPlural , ')'.
		currentCategory = cat key ifTrue:
			[html text: cat key; space; text: text.
			self renderCurrent: cat on: html]
		ifFalse:
			[(html anchor)
				callback: [currentCategory := cat key];
				text: cat key.
			html space.
			html text: text]
		]! !

!WAFAQ methodsFor: 'rendering' stamp: 'mb 8/18/2006 13:47'!
renderContentOn: html

	self renderTopOn: html.
	html heading: 'Frequently asked questions'.
	html orderedList:
		[self repository contents do:
			[:cat |
			html listItem: [self renderCategory: cat on: html]]]
! !

!WAFAQ methodsFor: 'rendering' stamp: 'mb 8/18/2006 14:01'!
renderCurrent: category on: html
	html orderedList:
		[category value do:
			[:faq |
			html listItem: [self renderQuestionAt: faq on: html]]].
! !

!WAFAQ methodsFor: 'rendering' stamp: 'mb 8/18/2006 13:49'!
renderQuestionAt: faq on: html

	faq isLink ifTrue:
			[(html anchor)
				url: faq response;
				text: faq question]
		ifFalse:
			[(html anchor)
				callback: [self displayResponseFor: faq];
				text: faq question]! !

!WAFAQ methodsFor: 'rendering' stamp: 'mb 8/18/2006 12:27'!
renderTopOn: html
	html image
		fileName: 'seaside-top.jpg';
		mimeType: 'image/jpeg';
		document: SeasidePlatformSupport seasideBanner
! !

!WAFAQ methodsFor: 'rendering' stamp: 'mb 1/11/2007 17:09'!
rendererClass
	^WAFAQCanvas! !

!WAFAQ methodsFor: 'model' stamp: 'mb 8/18/2006 15:25'!
repository
	^WAFAQRepository default! !

!WAFAQ methodsFor: 'css' stamp: 'mb 8/18/2006 19:11'!
style
	^'
body {
	font-family: Tahoma, Arial;
	font-size: 80%
}
div#spacer {
	height: 5em;
}
div#lightbox {
	background: white;
	border: 1px solid #0000e8;
	padding: 2em;
	width: 50em;
	height: 30em;
	text-align: center;
	overflow: scroll; 
}
div#overlay {
	background-color: black;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3;
}

'! !

WAFAQ subclass: #WAFAQResponse
	instanceVariableNames: 'faq'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Presentation'!

!WAFAQResponse class methodsFor: 'instance creation' stamp: 'mb 8/18/2006 14:08'!
for: faq
	^self new faq: faq! !

!WAFAQResponse methodsFor: 'accessing' stamp: 'mb 8/18/2006 14:16'!
faq
	^ faq! !

!WAFAQResponse methodsFor: 'accessing' stamp: 'mb 8/18/2006 14:16'!
faq: anObject
	faq := anObject! !

!WAFAQResponse methodsFor: 'rendering' stamp: 'mb 1/11/2007 17:17'!
renderContentOn: html
	html heading: faq title level: 3.
	faq response size > 600 ifTrue:
		[(html anchor)
			callback: [self answer];
			text: 'close'].
	(html div)
		style: 'text-align: left';
		style: 'margin: 2em';
		with:
			[faq isHtml ifTrue:
				[html html: faq response]
			ifFalse:
				[html withLineBreaks: faq response]].
	html div id: #spacer; with: ''.
	html form:
		[(html submitButton)
			callback: [self answer];
			text: 'Close'].
	html div id: #spacer; with: ''.
! !

WARenderCanvas subclass: #WAFAQCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Presentation'!

!WAFAQCanvas methodsFor: 'encoding' stamp: 'mb 1/11/2007 17:11'!
withLineBreaks: aString 
	| stream |
	aString
		ifNil: [^ self].
	stream := aString readStream.
	[stream atEnd]
		whileFalse: [self withTabs: stream nextLine.
			stream atEnd
				ifFalse: [self break]]		! !

!WAFAQCanvas methodsFor: 'encoding' stamp: 'mb 1/11/2007 17:12'!
withTabs: aString 
	| stream |
	stream := aString readStream.
	[stream atEnd]
		whileFalse:
			[self text: (stream upToAll: '	').
			stream atEnd ifFalse: [self space: 4]]! !

TestCase subclass: #WAFAQTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Tests'!

!WAFAQTests methodsFor: 'resources' stamp: 'mb 8/18/2006 15:26'!
repository
	^WAFAQRepository default! !

!WAFAQTests methodsFor: 'testing' stamp: 'mb 8/18/2006 16:26'!
testRepositoryContents
	| faqs |
	faqs := self repository contents.
	self assert: (faqs isKindOf: OrderedCollection).
	faqs do:
		[:each |
		self assert: (each isKindOf: Association).
		self assert: (each key isString).
		self assert: (each value isKindOf: SortedCollection).
		each value do:
			[:faq |
			self assert: faq class == WAFrequentlyAskedQuestion.
			self shouldnt: [faq isHtml. faq isLink. faq isText] raise: Error.
			self assert: (faq isHtml isKindOf: Boolean).
			self assert: (faq isText isKindOf: Boolean).
			self assert: (faq isLink isKindOf: Boolean).
			self assert: faq id isInteger.
			self assert: faq question isString.
			self assert: faq response isString.
			self assert: faq title isString.
			self assert: faq type isSymbol.



			]

]! !

!WAFAQTests methodsFor: 'testing' stamp: 'pmm 11/4/2006 17:29'!
testUniqueIds
	| faqs ids id |
	ids := Set new.
	faqs := self repository contents.
	faqs do: [:each |
		each value do: [:faq |
			id := faq id.
			self assert: id notNil.
			self assert: id isInteger.
			self deny: (ids includes: id).
			ids add: id ] ]! !
WAFAQ initialize!
